package com.JUnitAssignmentTests;

import com.JUnitAssignment.Adder;
import junitparams.Parameters;
import org.junit.Assert;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.junit.runners.Parameterized;

import java.util.Arrays;
import java.util.Collection;

import static org.junit.Assert.assertThat;

@RunWith(Parameterized.class)
public class ParametrizedTests {

    private int arg1;
    private int arg2;
    private int expectedResult;
    private Adder adder;

    public ParametrizedTests(int arg1, int arg2, int expectedResult) {
        this.arg1 = arg1;
        this.arg2 = arg2;
        this.expectedResult = expectedResult;
        this.adder = new Adder();
    }


    @Parameterized.Parameters
    public static Collection<Object[]> data() {
        return Arrays.asList(new Object[][]{
                {0, 0, 0}, {1, 1, 2}, {2, 2, 4}, {3, 3, 6}
        });
    }

    @Test
    public void additionTest() {
        System.out.printf("arg1: %d arg2: %d, expected result : %d\n", arg1, arg2, expectedResult);
        int sum = adder.add(arg1, arg2);
        Assert.assertEquals(sum, expectedResult);
    }
}
