package com.JUnitAssignmentTests;

import com.JUnitAssignment.Sorter;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import static org.junit.Assert.*;

public class SorterTest {
    Sorter sorter = new Sorter();

    public SorterTest() {
        System.out.println("inside Constructor");
    }

    @BeforeClass
    public static void beforeClass() {
        System.out.println("prints at the beginning of the class, beforeconstructor init");
    }

    @Test
    public void bubbleSortTest_assertTrue() {
        int[] unsortedArr = new int[]{5,4,3,2,1};
        int[] expectedResult = new int[]{1,2,3,4,5};

        sorter.bubbleSort(unsortedArr);
        assertTrue("Test Failed", Arrays.equals(expectedResult, unsortedArr));
    }

    @Test
    public void bubbleSortTest_assertEquals() {
        int[] arr = new int[]{10,4,3,-1,6};
        sorter.bubbleSort(arr);

        assertEquals(arr, arr);
    }

    @Test
    public void bubbleSortTest_assertNotEquals() {
        int[] arr = new int[]{10,4,3,-1,6};
        sorter.bubbleSort(arr);

        assertNotEquals(new int[] {-1,3,4,6,10}, arr);
    }

    @Test
    public void bubbleSortTest_assertArrayEquals() {
        int[] arr = new int[]{10,4,3,-1,6};
        sorter.bubbleSort(arr);

        assertArrayEquals(new int[] {-1,3,4,6,10}, arr);
    }




}
